#!/usr/bin/env python
# -*- Python -*-


"""
  \file RTCUtil.py
  \brief RTComponent utils
  \date $Date: 2007/09/11 $
  \author Noriaki Ando <n-ando@aist.go.jp> and Shinji Kurihara
 
  Copyright (C) 2007
      Task-intelligence Research Group,
      Intelligent Systems Research Institute,
      National Institute of
          Advanced Industrial Science and Technology (AIST), Japan
      All rights reserved.
"""

from omniORB import CORBA

import RTC, RTC__POA

def isDataFlowParticipant(obj):
	dfp = obj._narrow(RTC.DataFlowParticipant)
	return not CORBA.is_nil(dfp)

def isFsmParticipant(obj):
	fsmp = obj._narrow(RTC.FsmParticipant)
	return not CORBA.is_nil(fsmp)

def isFsmObject(obj):
	fsm = obj._narrow(RTC.FsmObject)
	return not CORBA.is_nil(fsm)

def isMultiModeObject(obj):
	mmc = obj._narrow(RTC.MultiModeObject)
	return not CORBA.is_nil(mmc)
